	ORG 6000H
WELC	DB 'A S T E R O I D   B E L T',13,13
	DB 'by Knut Roll-Lund  (c) 1982, 2001',13,13
	DB 'Avoid the asteroids',13,13
	DB 'Press BREAK to end the game',13
	DB 'Press CLEAR to clear scores',13,13
	DB 'Bravo player (B=-) : Port 0 joystick',13
	DB '   or up and down arrows',13
	DB 'Delta player (D=-) : Port 1 joystick',13
	DB '   or ; or A for up and / or Z for down',13,0
LEVEL	DB 13,'Level? (0 difficult -> 7 easy)',0
LEFT	DB 'Bravo',0
RIGHT	DB 'Delta',0
TRUF	DB ' was hit by an asteroid!',13,0
BCR	DS 1
DCR	DS 1
;move ship macro
MSHIP	MACRO #SH,#OPR
	LD (HL),#SH
	INC HL
	LD (HL),'='
	INC HL
	LD (HL),'-'
	OR A
	#OPR HL,DE
	LD (HL),' '
	DEC HL
	LD (HL),' '
	DEC HL
	LD (HL),' '
	ENDM
;
START	DI		;no more need for interrupts
	XOR A
	LD (BCR),A	;b score to 0
	LD (DCR),A	;d score to 0
	CALL 1C9H	;CLS
	LD HL,4090H	;random fixed seed
	LD (HL),40H	;initalize with same values as rom
	INC HL
	LD (HL),0E6H
	INC HL
	LD (HL),4DH
	LD HL,WELC
	CALL WRIT
;menu loop
UP	LD HL,LEVEL
	CALL WRIT
O1	LD A,(3840H)
	AND 6		;clear or break?
	JR Z,N1
	AND 4
	JR Z,START
	CALL 1C9H	;CLS
	EI
	JP 402DH	;to dos
N1	LD A,(3810H)
	OR A
	JR Z,O1
	LD HL,16
	LD DE,16
HUP	ADD HL,DE
	SRL A
	JR NZ,HUP
	LD (RNDST+1),HL
HPROG	OR A
	CALL 1C9H	;CLS
	LD HL,3DC0H
	LD DE,40H
	LD (HL),'B'
	INC HL
	LD (HL),'='
	INC HL
	LD (HL),'-'
	ADD HL,DE
	LD (HL),'-'
	DEC HL
	LD (HL),'='
	DEC HL
	LD (HL),'D'
TUP	CALL MOVSK
	CALL MOVE
	CALL MOVSK
	CALL MOVSK
	JR TUP
;
MOVSK	CALL RNDST
	LD HL,3C00H
MTUP	LD A,(HL)
	CP '*'
	JR NZ,MTHER
	PUSH HL
	CALL MOVST
	POP HL
MTHER	INC HL
	LD A,H
	CP 40H
	JR NZ,MTUP
	RET
MOVST	LD A,L
	AND 3FH
	OR A
	JR Z,DISAP
	DEC HL
	LD A,(HL)
	CP ' '
	JR NZ,MTOUT
	LD (HL),'*'
	INC HL
DISAP	LD (HL),' '
	RET
;
MTOUT	POP BC
	POP BC
	LD B,0
	INC HL
	LD (HL),' '
	DEC HL
	DEC HL
	LD (HL),143
W1	DJNZ W1
W2	DJNZ W2
	LD (HL),'X'
	DEC HL
	LD D,(HL)
	LD (HL),'>'
	INC HL
	INC HL
	LD (HL),'<'
W3	LD C,B
	LD B,0
W4	DJNZ W4
	LD B,C
	DJNZ W3
	OR A
	CALL 1C9H
	LD A,D
	CP 'B'
	JR Z,FA
	LD A,(DCR)
	INC A
	LD (DCR),A
	LD HL,RIGHT
	CALL WRIT
	JR FB
FA	LD A,(BCR)
	INC A
	LD (BCR),A
	LD HL,LEFT
	CALL WRIT
FB	LD HL,TRUF
	CALL WRIT
	CALL GRAPH
	JP UP
;
FINB	LD HL,15360
	LD DE,64
FBO	LD A,(HL)
	CP 'B'
	RET Z
	ADD HL,DE
	JR FBO
;
FIND	LD HL,3FC0H
	LD DE,40H
FDO	LD A,(HL)
	CP 'D'
	RET Z
	OR A
	SBC HL,DE
	JR FDO
;
MOVE	LD BC,0
	LD A,(3840H)
	AND 8
	JR NZ,MVB0
	IN A,(0)
	AND 1
	JR NZ,MVB0+1
MVB0	INC B		;B wants up
	LD A,(3840H)
	AND 16
	JR NZ,MVB1
	IN A,(0)
	AND 2
	JR NZ,MVB1+2
MVB1	INC B		;B wants down
	INC B
	LD A,(3801H)
	AND 2
	JR NZ,MVD0
	LD A,(3820H)
	AND 8
	JR NZ,MVD0
	IN A,(1)
	AND 1
	JR NZ,MVD0+1
MVD0	INC C		;D wants up
	LD A,(3808H)
	AND 4
	JR NZ,MVD1
	LD A,(3820H)
	AND 80H
	JR NZ,MVD1
	IN A,(1)
	AND 2
	JR NZ,MVD1+2
MVD1	INC C		;D wants down
	INC C
	LD A,B
	CP 1
	JR NZ,MV0
	CALL FINB
	SBC HL,DE
	LD A,H
	CP 3CH
	JR C,MV0
	MSHIP 'B',ADD	;Move B up
MV0	LD A,C
	CP 2
	JR NZ,MV1
	CALL FIND
	ADD HL,DE
	LD A,H
	CP 40H
	JR NC,MV1
	MSHIP 'D',SBC	;Move D down
MV1	CALL FINB
	LD A,B
	CP 2
	JR NZ,MV3
	LD A,C
	CP 1
	JR NZ,MV2
	ADD HL,DE
	LD A,(HL)
	CP 'D'
	RET Z
MV2	ADD HL,DE
	LD A,(HL)
	CP 'D'
	RET Z
	CALL FINB
	ADD HL,DE
	MSHIP 'B',SBC	;Move B down
MV3	LD A,C
	CP 1
	RET NZ
	CALL FIND
	SBC HL,DE
	LD A,(HL)
	CP 'B'
	RET Z
	MSHIP 'D',ADD	;Move D up
	RET
;
RNDST	LD HL,50
	OR A
	CALL 14CCH	;bios RND(HL)
	CP 18
	RET NC
	LD HL,3BFFH
	LD DE,40H
RNUP	DEC A
	JR Z,RNND
	ADD HL,DE
	JR RNUP
RNND	LD (HL),'*'
	RET
;write zeroterminated string to @DO
WRIT	LD A,(HL)
	OR A
	RET Z
	PUSH HL
	CALL 33H
	POP HL
	INC HL
	JR WRIT
;display score bargraphs
GRAPH	LD HL,3CC0H
	LD (HL),'B'
	INC HL
	LD (HL),':'
	LD HL,3D00H
	LD A,(BCR)
	LD C,187
	OR A
	JR Z,GUP
	LD (HL),170
	INC HL
GPP	LD (HL),C
	INC HL
	DEC A
	JR NZ,GPP
GUP	LD HL,3E00H
	LD (HL),'D'
	INC HL
	LD (HL),':'
	LD HL,3E40H
	LD A,(DCR)
	LD C,187
	OR A
	RET Z
	LD (HL),170
	INC HL
GNP	LD (HL),C
	INC HL
	DEC A
	JR NZ,GNP
	RET
	END START
